function yTest = DP_Classify(xTrain, yTrain, xTest, mode)

addpath('Documents/Research/Phd/Codes/DP/vdpgm_Kenichi/');

opts = mkopts_avdp;
opts.get_q_of_z = 1;
opts.use_kd_tree = 0;

xTest = xTest'; yTrain = yTrain'; xTrain = xTrain';

if strcmp(mode, 'multiVari')
    prbFeatTrain = xTrain(:,(yTrain==true));
    normalFeatTrain = xTrain(:,(yTrain==false));
    % Model training
    prbGMM = vdpgm(prbFeatTrain, opts);
    normalGMM = vdpgm(normalFeatTrain, opts);

    prbGMM.test_data = xTest;
    prbMd_lik = vdpgm(prbFeatTrain, prbGMM);
    normalGMM.test_data = xTest;
    normalMd_lik = vdpgm(normalFeatTrain, normalGMM);

    lik_ratio = bsxfun(@minus,prbMd_lik.predictive_posterior,normalMd_lik.predictive_posterior);
%     yTest = (lik_ratio>=0)';
    yTest = (lik_ratio>=-0.2877)';
end

if strcmp(mode, 'expVote')
    featNum = size(xTrain,1);
    lik_ratio = zeros(size(xTest));
    for featInd = 1:featNum
        prbFeatTrain = xTrain(featInd,(yTrain==true));
        normalFeatTrain = xTrain(featInd,(yTrain==false));
        % Model training
        prbGMM = vdpgm(prbFeatTrain, opts);
        normalGMM = vdpgm(normalFeatTrain, opts);

        prbGMM.test_data = xTest(featInd,:);
        prbMd_lik = vdpgm(prbFeatTrain, prbGMM);
        normalGMM.test_data = xTest(featInd,:);
        normalMd_lik = vdpgm(normalFeatTrain, normalGMM);

        lik_ratio(featInd,:) = bsxfun(@minus,prbMd_lik.predictive_posterior,normalMd_lik.predictive_posterior);
    end
    
    yTest = (mean((lik_ratio>=0),1)>=0.5)'; % expert vote with equal votes as apnea
%     yTest = bsxfun(@or, mean((lik_ratio>=0),1)>0.5,bsxfun(@and,...
%     mean((lik_ratio>=0),1)==0.5,lik_ratio(1,:)>=0))';  % expert vote with equal vote as 'CTM' result
%     yTest = (sum(lik_ratio,1)>=0)'; % probability multiplied
end

if strcmp(mode, 'comb') % combine multivariate and expertVote
    subset = {[1]; [2,3,4,5]}; 
    subsetNum = length(subset);
    lik_ratio = zeros(subsetNum,size(xTest,2));
    for subsetInd = 1:subsetNum
        prbFeatTrain = xTrain(subset{subsetInd},(yTrain==true));
        normalFeatTrain = xTrain(subset{subsetInd},(yTrain==false));
        % Model training
        prbGMM = vdpgm(prbFeatTrain, opts);
        normalGMM = vdpgm(normalFeatTrain, opts);

        prbGMM.test_data = xTest(subset{subsetInd},:);
        prbMd_lik = vdpgm(prbFeatTrain, prbGMM);
        normalGMM.test_data = xTest(subset{subsetInd},:);
        normalMd_lik = vdpgm(normalFeatTrain, normalGMM);

        lik_ratio(subsetInd,:) = bsxfun(@minus,prbMd_lik.predictive_posterior,normalMd_lik.predictive_posterior);
    end
    yTest = (sum(lik_ratio,1)>=0)';
%     yTest = (mean((lik_ratio>=0),1)>=0.5)';
end
end