% Processing sleeping videos with GMM based background subtraction algorithm
% to detect motion
%%

allvideodir = '../../../Data/';
files = dir(allvideodir);
subSmpRt = 1;
for vidind = 1:3 %length(files)
    filename = '620310565181_7.asf';
    if files(vidind).isdir
        continue;
    end
%     filename = files(vidind).name;
    videofile = fullfile(allvideodir,filename);
    input = VideoReader(videofile);
    framenum = input.numberOfFrames;
    input = VideoReader(videofile);
    hgt = input.Height;
    wdh = input.Width;
    pnum = hgt*wdh;
    fps = input.FrameRate;
    motInd = zeros(framenum,2);
    
    %% 
    n_frames = 100; % frames to update models
    n_gaussians = 5; % number of Gaussian componets
    detector = vision.ForegroundDetector('NumTrainingFrames', n_frames, ...
               'NumGaussians', n_gaussians, 'MinimumBackgroundRatio',0.9);

                               
    blob = vision.BlobAnalysis(...
       'CentroidOutputPort', false, 'AreaOutputPort', false, ...
       'BoundingBoxOutputPort', true, ...
       'MinimumBlobAreaSource', 'Property', 'MinimumBlobArea', 150);
    %% Output video configuration
%     outputVid = VideoWriter(fullfile(allvideodir,'Output',strcat(filename(1:end-4),'_output.avi')),'Uncompressed AVI');
%     outputFps = round(fps/subSmpRt);
%     outputVid.FrameRate = outputFps;
%     open(outputVid);
    %%
    % flag = zeros( framenum, 1); % frame-wise label array
    frameind = 1;
    while(hasFrame(input))
        frameRGB = readFrame(input);
        frameGray = rgb2gray(frameRGB);
        motInd(frameind,2) = input.CurrentTime;
        if mod(frameind,subSmpRt)~=0
            frameind = frameind+1;
            continue;
        end
        disp(['frame number:' ,num2str(frameind)]);
        fgMask = detector(frameGray);       
        bbox = blob(fgMask);
        figure(1);
        subplot(1,2,1); imshow(frameGray); 
        title(strcat('Original frame:',num2str(frameind)));
        subplot(1,2,2); imshow(fgMask); hold on;

%         out= shapeInserter(frame,bbox);
        
%         subplot(2,3,5); imshow(Tb);
%         subplot(2,3,6); imshow(medfilt2(bsxfun(@gt, abs(FgDif), Tb), [5 5])); title('Moving regions');
%         hold on;
% 
        if ~isempty(bbox)
            disp('Stop');
            xlabel('Moving!!','FontSize',12,'FontWeight','bold','Color','r');
            motInd(frameind-subSmpRt+1:frameind,1) = 1;
            out = insertShape(frameRGB, 'Rectangle', bbox);
            figure(2); imshow(out);
        else
            xlabel('No motion','FontSize',12,'Color','b');
        end
        hold off;
%         frame = getframe(h);    
%         writeVideo(outputVid,frame.cdata);
%         drawnow;
        frameind = frameind+1;
    end
%     close(outputVid);
    
    load(fullfile(allvideodir,strcat(filename(1:end-4),'_gt.mat')),'Gt');
    confusion_mat = confusionmat(Gt,motInd);
    if size(confusion_mat,1)>1
        neg_num = sum(confusion_mat(1, :));
        pos_num = sum(confusion_mat(2, :));
        if neg_num ~= 0
            tnr = confusion_mat(1,1)/neg_num;
        else
            tnr = [];
        end
        if pos_num ~= 0
            tpr = confusion_mat(2,2)/pos_num;
        else
            tpr = [];
        end
    elseif sum(gt_arr)==0
        tnr = 1;
        tpr = [];
    elseif sum(gt_arr)~=0
        tpr= 1;
        tnr = [];
    end
    
    motIndtmp = find(motInd(:,1));
    motIndtmp = cat(2,motIndtmp, sec2regTime(motIndtmp(:,2)));
    motInd = array2table(motIndtmp,'VariableNames',{'FrameInd','h','m','s'});
    clear motIndtmp;
%     writetable(motInd,fullfile(allvideodir,'Output',strcat(filename(1:end-4),'_MotiongTempInd.txt')));
    save(fullfile(allvideodir,'Output',strcat(filename(1:end-4),'_MotiongTempInd.mat')),'motInd','tpr','tnr');
end