% Processing sleeping videos with R-PCA to detect motion
%% path setting
% addpath('/home/zli/Documents/Research/codes/PCA_Background_Det/lrslibrary/');
% addpath('/home/zli/Documents/Research/codes/PCA_Background_Det/lrslibrary/algorithms/rpca/STOC-RPCA/');
%%
% allvideodir = '/home/zli/Documents/Research/Database/Videos4Exp/neg/';
% filename = 'smoke_or_flame_like_object_1.avi';

allvideodir = '../../../Data/';
files = dir(allvideodir);
subSmpRt = 5;
for vidind = 1:3 %length(files)
    filename = '620310565181_7.asf';
    if files(vidind).isdir
        continue;
    end
%     filename = files(vidind).name;
    videofile = fullfile(allvideodir,filename);
    input = VideoReader(videofile);
    framenum = input.numberOfFrames;
    input = VideoReader(videofile);
    hgt = input.Height;
    wdh = input.Width;
    pnum = hgt*wdh;
    fps = input.FrameRate;
    motInd = zeros(framenum,2);
    
    % %% STOC_RPCA param init
    % lambda1 = 1/sqrt(pnum);
    % lambda2 = lambda1;
    % %         nrank = framenum;
    % nrank = 100;
    % ndim = pnum;
    % L = rand(ndim,nrank);
    % A = zeros(nrank,nrank);
    % B = zeros(ndim,nrank);

    %% Recursive background subtraction method initialisation
    Bg = rgb2gray(readFrame(input)); % background matrix
    Tb = uint8(5*ones(hgt,wdh)); % threshold matrix
    frameGray_prev = Bg;
    frameGray_prev_2 = Bg;
    alpha = 0.8; % smoothing parameter
    c = 5;

    %% Output video configuration
%     outputVid = VideoWriter(fullfile(allvideodir,'Output',strcat(filename(1:end-4),'_output.avi')),'Uncompressed AVI');
%     outputFps = round(fps/subSmpRt);
%     outputVid.FrameRate = outputFps;
%     open(outputVid);
    %%
    % flag = zeros( framenum, 1); % frame-wise label array
    frameind = 2;
    while(hasFrame(input))
        frameRGB = readFrame(input);
        frameGray = rgb2gray(frameRGB);
        motInd(frameind,2) = input.CurrentTime;
        if mod(frameind,subSmpRt)~=0
            frameind = frameind+1;
            frameGray_prev2 = frameGray_prev;
            frameGray_prev = frameGray;
            continue;
        end
        disp(['frame number:' ,num2str(frameind)]);
%         h = figure('visible','off'); 
        figure(1);
%         h.WindowState = 'maximized';
        subplot(2,3,1); imshow(frameRGB); 
        title(strcat('Original frame:',num2str(frameind)));

%         if frameind == subSmpRt
%             Bg = frameGray;
%             frameGray_prev = frameGray;
%             frameind = frameind+1;
%             continue;
%         end

%         frameDif = frameGray-frameGray_prev; % frameGray difference
        mvReg1 = bsxfun(@gt, abs(frameGray-frameGray_prev), Tb);
        mvReg2 = bsxfun(@gt, abs(frameGray-frameGray_prev2), Tb);
        mvReg = bsxfun(@and, mvReg1, mvReg2); % moving regions
        subplot(2,3,3); imshow(mvReg); title('Frame Difference, no medfilter');
        subplot(2,3,2); imshow(Bg); title('Background');
        
        FgDif = frameGray-Bg; % frameGray - Bg
        % Update thresholds
%         Tb(~mvReg) = alpha*Tb(~mvReg)+(1-alpha)*c*abs(FgDif(~mvReg));
        tmp1 = c*abs(FgDif)-Tb; tmp1(mvReg) = 0;
        Tb = Tb+(1-alpha)*tmp1;

        % update background model
%         Bg(~mvReg) = alpha*Bg(~mvReg)+(1-alpha)*frameGray(~mvReg);
        tmp2 = FgDif; tmp2(mvReg) = 0;
        Bg = Bg + (1-alpha)*tmp2; 
        
%         subplot(2,3,4); contourf(Tb); colorbar; title('Threshold');
%         subplot(2,3,5); contourf(FgDif); colorbar; title('Intensity-background');

    %     frameGray = im2double(reshape(frameGray,[],1));
    %     % STOC-RPCA
    %     [r,s] = solve_proj2(frameGray,L,lambda1,lambda2);
    % %             S(:,frameind) = s;
    %     A = A + r*r';
    %     B = B + (frameGray-s)*r';
    %     L = update_col(L,A,B,lambda1/nrank);
    % %             Lr(:,frameind) = L * r;
    % 
    %     O = hard_threshold(s);  % binary results
    %     Outlier = reshape(O,hgt,wdh);
    %     Outlier = mat2gray(Outlier);
    %     Outlier = im2uint8(Outlier);
    %     Outlier = medfilt2(Outlier, [5 5]); % median filter
    % 
    %     rgbImage = repmat(Outlier,[1 1 3]);
    %     subplot(1,2,2);
    %     imshow(rgbImage); title('STOC-RPCA results');
        subplot(2,3,5); imshow(Tb);
        subplot(2,3,6); imshow(medfilt2(bsxfun(@gt, abs(FgDif), Tb), [5 5])); title('Moving regions');
        hold on;

        if sum(sum(medfilt2(bsxfun(@gt, abs(FgDif), Tb), [5 5])))>100&&frameind>100*subSmpRt
            disp('Stop');
            xlabel('Moving!!','FontSize',12,'FontWeight','bold','Color','r');
            motInd(frameind-subSmpRt+1:frameind,1) = 1;
        else
            xlabel('No motion','FontSize',12,'Color','b');
        end
        hold off;
%         frame = getframe(h);    
%         writeVideo(outputVid,frame.cdata);
%         drawnow;
        frameind = frameind+1;
        frameGray_prev2 = frameGray_prev;
        frameGray_prev = frameGray;
    end
%     close(outputVid);
    
    load(fullfile(allvideodir,strcat(filename(1:end-4),'_gt.mat')),'Gt');
    confusion_mat = confusionmat(Gt,motInd);
    if size(confusion_mat,1)>1
        neg_num = sum(confusion_mat(1, :));
        pos_num = sum(confusion_mat(2, :));
        if neg_num ~= 0
            tnr = confusion_mat(1,1)/neg_num;
        else
            tnr = [];
        end
        if pos_num ~= 0
            tpr = confusion_mat(2,2)/pos_num;
        else
            tpr = [];
        end
    elseif sum(gt_arr)==0
        tnr = 1;
        tpr = [];
    elseif sum(gt_arr)~=0
        tpr= 1;
        tnr = [];
    end
    
    motIndtmp = find(motInd(:,1));
    motIndtmp = cat(2,motIndtmp, sec2regTime(motIndtmp(:,2)));
    motInd = array2table(motIndtmp,'VariableNames',{'FrameInd','h','m','s'});
    clear motIndtmp;
%     writetable(motInd,fullfile(allvideodir,'Output',strcat(filename(1:end-4),'_MotiongTempInd.txt')));
    save(fullfile(allvideodir,'Output',strcat(filename(1:end-4),'_MotiongTempInd.mat')),'motInd','tpr','tnr');
end