function [label,perf] = perfCalc(prbMd, normalMd, prbTrainData, normalTrainData,testData)
% the function provide binary results of each sub-seq based on features 
% from each sub-signal and the trained DPMM models, and calculate the acc, 
% sens and spec of the results
prbMd.test_data = testData(1:end-1,:);
prbMd_lik = vdpgm(prbTrainData, prbMd);

normalMd.test_data = testData(1:end-1,:);
normalMd_lik = vdpgm(normalTrainData, normalMd);
lik_ratio = bsxfun(@minus,prbMd_lik.predictive_posterior,normalMd_lik.predictive_posterior);
label = (lik_ratio>=0);
gt = testData(end,:);
perf.acc = 1-sum(abs(label-gt))/size(testData,2);
prbDataInd = find(testData(end,:)==1);
normalDataInd = find(testData(end,:)==0);
perf.sens = sum(label(prbDataInd)==1)/length(prbDataInd);
perf.spec = sum(label(normalDataInd)==0)/length(normalDataInd);
end